Subject: Re: [PATCH] net: fix race in the receive/select

From: Andi Kleen <[email-masked]>
Date: Mon, 29 Jun 2009 11:12:33 +0200

Jiri Olsa <[email-masked]> writes:

> Adding memory barrier to the __pollwait function paired with 
> receive callbacks.  The smp_mb__after_lock define is added, 
> since {read|write|spin}_lock() on x86 are full memory barriers.

I was wondering did you see that race actually happening in practice?
If yes on which system?

At least on x86 I can't see how it happens. mb() is only a compile
time barrier and the compiler doesn't optimize over indirect callbacks
like __pollwait() anyways.

It might be still needed on some weaker ordered architectures, but did you
actually see it there?

-Andi

-- 
[email-masked] -- Speaking for myself only.